/*********************************************************\
*  AVR MegaSquirt - 2003                                  *
*  (C) 2003 [Michael Kristensen, mik@caffrey.dk]          *
***********************************************************
*  -- History --                                          *
*    release 0.1 - 06-03-2003                             *
*            http://caffrey.dk/megasquirt                 *
*    initial Motorola version by Bowling & Grippo (2002)  *
*            http://www.bgsoflex.com/megasquirt.html      *
\*********************************************************/


#ifndef __HELPERS_H__
#define __HELPERS_H__

#include "global.h"
#include <inttypes.h>

// argument to search_table function
struct search_table_t {
  uint8_t lindex;
  uint8_t uindex;
};

struct mfilter_t {
  uint8_t buf[3];
};

// check scale_x() and linear interpolation before changing word length
typedef uint8_t scale_t ;	// where no benefit from 16 bit scale (8 bit is enough)
typedef uint16_t scaleprec_t ;	// where 16 bit scale precision is needed

uint8_t linear_interp(uint8_t x1, uint8_t x2, uint8_t y1, uint8_t y2, uint8_t x);
uint8_t linear_interp_allow_swap(uint8_t x1, uint8_t x2, uint8_t y1, uint8_t y2, uint8_t x);
uint16_t linear_interp16(uint8_t x1, uint8_t x2, uint16_t y1, uint16_t y2, uint8_t x);
void update_rx21(uint8_t *src, uint16_t *target, uint8_t idx, uint8_t limit);
void search_table(uint8_t *tbl, uint8_t tbl_length, uint8_t item, struct search_table_t *r);
uint16_t mult_div100(uint8_t a, uint16_t b);
uint16_t mult_div10(uint8_t a, uint16_t b);
uint16_t mult_div596(uint16_t a, uint16_t b);
uint16_t mult_div10k(uint16_t a, uint16_t b);
uint16_t mult_div25600(uint16_t a, uint16_t b);
uint8_t median_filter(struct mfilter_t *f, uint8_t in);
int16_t limit_i16(int16_t val, int16_t upper, int16_t lower);
int8_t limit_i8(int8_t val, int8_t upper, int8_t lower);
uint8_t limit_u8(uint8_t val, uint8_t upper, uint8_t lower);
__inline__ uint8_t min(uint8_t a, uint8_t b);
__inline__ uint8_t max(uint8_t a, uint8_t b);
uint8_t interpol16(uint8_t *tab, uint8_t table_size, uint8_t index);
uint8_t interpol8(uint8_t *tab, uint8_t table_size, uint8_t index);
#define timebase_to_10usec(t) (mult16_8( t, 102) >> 8)


extern uint16_t PROGMEM RX21LOOKUP[];
static inline uint16_t div_65535_x( uint8_t v )
{
	return pgm_read_word( RX21LOOKUP + (uint16_t) v);
}
uint8_t linear_interp_fixed_y(uint8_t x1, uint8_t x2, uint8_t x);

#endif
