

#ifdef CAPTURE_ALIEN_ECU


#include "global.h"
#include "ign_logging.h"
#include "comm.h"
#include "adc.h"
#include "ve.h"
#include "injector.c"

#include <inttypes.h>
#include <avr/io.h>
#include <stdlib.h>
#include <avr/interrupt.h>


void alien_mapsensor_log(void) {
	uint8_t *comm_TX_plainbytesP;
	uint16_t t16;

	comm_TX_plainbytesP = comm_TX_plainbytes;
	// let the sample start with "\r\na="
	* comm_TX_plainbytesP++ = '\r';
	* comm_TX_plainbytesP++ = '\n';
	* comm_TX_plainbytesP++ = 'm';
	* comm_TX_plainbytesP++ = '=';

	t16 = engine.kpa250;
	*comm_TX_plainbytesP++ = t16 >> 8;
	*comm_TX_plainbytesP++ = (uint8_t)(t16);

	t16 = sensors11(KNOCK);
	*comm_TX_plainbytesP++ = t16 >> 8;
	*comm_TX_plainbytesP++ = (uint8_t)(t16);

#define ALIEN_MAPSENSOR_TOTAL_LEN (4+2+2)
	pushfuncpar(NULL, ALIEN_MAPSENSOR_TOTAL_LEN, comm_TX_plainbytes);

}


void alien_detailed_log(void) {
	uint8_t *comm_TX_plainbytesP;
	uint16_t t16;

	comm_TX_plainbytesP = comm_TX_plainbytes;
	// let the sample start with "\r\na="
	* comm_TX_plainbytesP++ = '\r';
	* comm_TX_plainbytesP++ = '\n';
	* comm_TX_plainbytesP++ = 'a';
	* comm_TX_plainbytesP++ = '=';

	* comm_TX_plainbytesP++ = engine.alien_ignadv;
	* comm_TX_plainbytesP++ = engine.alien_dwell;

	t16 = engine.rpm_vhr;
	*comm_TX_plainbytesP++ = t16 >> 8;
	*comm_TX_plainbytesP++ = (uint8_t)(t16);

	t16 = engine.kpa250;
	*comm_TX_plainbytesP++ = t16 >> 8;
	*comm_TX_plainbytesP++ = (uint8_t)(t16);

	// calculate log size: 4(header) +1(alien_ignadv) +1(alien_dwell) +2(rpm_vhr) +2(kpa250) +2(adc)
#define ALIEN_LOG_TOTAL_LEN (4+1+1+2+2)
	pushfuncpar(NULL, ALIEN_LOG_TOTAL_LEN, comm_TX_plainbytes);

}	// alien_detailed_log



#include "softpwm.c"

struct softpwm_t map_pwm_soft, clt_pwm_soft;

#define MAP_CHANNEL hwmap.table[8]
#define CLT_CHANNEL hwmap.table[9]
#define MAP_VAL     hwmap.table[10]
#define CLT_VAL     hwmap.table[11]

void init_alien_logging_stimuli(void) {
	softpwm_init(&map_pwm_soft, 0);
	softpwm_init(&clt_pwm_soft, 0);
}

void alien_logging_stimuli(void) {
	uint8_t output;

	softpwm_set(&map_pwm_soft, MAP_VAL);
	output = softpwm_act(&map_pwm_soft);
	cli();
	digitalout(MAP_CHANNEL, output);
	sei();

	softpwm_set(&clt_pwm_soft, CLT_VAL);
	output = softpwm_act(&clt_pwm_soft);
	cli();
	digitalout(CLT_CHANNEL, output);
	sei();
}

#endif
