
#ifndef __LCD_DISPLAY_H__
#define __LCD_DISPLAY_H__

#include "menu.h"
#include <avr/io.h>
#include <stdio.h>
#include <stdarg.h>

struct lcd_display_t {
	uint8_t firstline;  // index of the line at the top of the displayed page
	uint8_t funcarridx; // upper nibble: lineidx (add to firstline to get absolute address); lower nibble: funcidx inside the line
	uint8_t mode;	// see enums below
	uint8_t param;	// mode specific
	struct menu_t *menu;
};

// mode:
enum { DISPLAY_INTRO, DISPLAY_NORMAL, DISPLAY_TABLE, DISPLAY_HOLD };

extern struct lcd_display_t lcd_disp;

void lcd_do_something(void);
__inline__ void lcd_display_mode(uint8_t, struct menu_t*);
// void lcd_display_pos(struct menu_t*);
__inline__ void lcd_display_select_list(uint8_t i);

void lcd_display_lineinc(uint8_t x);
void lcd_display_linedec(uint8_t x);

#define lcd_display_setpage(x) lcd_disp.firstline=x*LCD_LINES
#define lcd_display_nextpage() lcd_display_lineinc(LCD_LINES)
#define lcd_display_prevpage() lcd_display_linedec(LCD_LINES)
#endif

