/*********************************************************\
*  AVR MegaSquirt - 2003                                  *
*  (C) 2003 [Marcell Gal cell at x-dsl.hu]                *
***********************************************************
* used for some time calcs (included, not linked)     *
\*********************************************************/

   /*!
   * \addtogroup g_event_queues Event Queues
   */
/*@{*/

#ifndef __REENABLE_C__
#define __REENABLE_C__
#include "eventqueue.h"

// return ((uint32_t)etime.now_upper<<16) + etime.now;
static inline uint32_t now32(void)
{
	uint32_t n;
asm (
	"\n"
	"movw %A0, %A2 \n\t" // now 
	"movw %C0, %A1 \n\t" // now_upper
	: "=&r" (n)
	: "r" (etime.now_upper), "r" (etime.now)
	);
	return n;
}

// faster than if(t32 >> 16)
static inline uint8_t upper_word_nonzero(uint32_t t32)
{
	uint8_t n;
asm (
	"\n"
	"mov %A0, %C1 \n\t" // lower byte of upper word (could this be eliminated?)
	"or %A0, %D1 \n\t" 	// higher byte of upper word
	: "=&r" (n)
	: "r" (t32)
	);
	return n;
}

// used for calculating when to reenabe interrupt
// input is 4 usec resolution
static inline uint16_t reenable_time(uint32_t period32)
{
	uint16_t reenable;
	
	if(upper_word_nonzero(period32))
		return TRIGGER_REENABLE_MAX;
	else
		reenable = (uint16_t)period32;

	// we reenable after max 1/2 of previous rpm_period
	reenable >>= 1;

	// let's rail it to limits
	if (reenable > TRIGGER_REENABLE_MAX) return TRIGGER_REENABLE_MAX;

	return reenable - 60; 
	// subtract 240 usec so it is not locked on double-period
	// in case of a precise table-testing setup
	// don't worry about negative reenable (it works!)
}
#endif

/*@}*/

